﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        private struct TTanuló//Rekordtípus meghatározása
        {
            public string Név;
            public float Átlag;
            
            public TTanuló(string _Név, float _Átlag)//Paraméteres konstruktor, így születik meg a rekord
            {
                Név = _Név;
                Átlag = _Átlag;
            }
        }

        static void Beolvasás(out int N, TTanuló[] X)
        {
            //Elemszám beolvasása
            //A felhasználónak szánt tájékoztató üzenetek az Error csatotnára írandók! A standard output így nézne ki: Console.WriteLine("Hány eleme van a tömbnek?");
            //Például a kérdések:
            Console.Error.WriteLine("Hány tanuló jár az osztályba? ");
            N = Convert.ToInt32(Console.ReadLine());
            //A tömb beolvasása
            for (int i = 0; i<N; i++)
            {
                Console.Error.WriteLine("A(z) "+(i+1)+". tanuló neve és átlaga, enterrel elválasztva: ");
                X[i] = new TTanuló(Console.ReadLine(), Convert.ToSingle(Console.ReadLine()));//Nevek és átlagok egymás alatt vannak.
            }
        }

        static int Kiválogatás(int N, TTanuló[] X, string[] Név)
        {
            int Db = 0;
            for (int i=0;i<N;i++)
            {
                if (X[i].Átlag >= 4)
                {
                    Db++;
                    Név[Db - 1] = X[i].Név;
                }
            }
            return Db;
        }

        static void Kiírás(int Db, string[] Név)
        {
            //A kimenetet kísérő szövegek is az Error csatornára irandók!
            if (Db==0)
            {
                Console.WriteLine("NINCS");
            }
            else
            {
                Console.WriteLine(Db);
                for (int i=0; i<Db; i++)
                {
                    Console.WriteLine(Név[i]);
                }
            }
        }

        static void Main(string[] args)
        {
            //F5. Adjuk meg egy osztály azon tanulóit, akik jeles (legalább 4-es) átlagúak!
            //Maximális elemszám
            const int MaxN = 100;
            //A tömb elemszámának deklarálása
            int N;
            //A tömb deklarálása
            TTanuló[] X = new TTanuló[MaxN];
            //Kimeneti adatok deklarálása
            string[] Név = new string[MaxN];
            int Db;
            //Beolvasás
            Beolvasás(out N, X);//out N: N kimeneti paraméter, tömbnél nincs külön jelölése
            //Lényegi megoldás
            Db = Kiválogatás(N,X,Név);
            //Kiírás
            Kiírás(Db,Név);
        }
    }
}
